package Nix::Config;

$version = "1.8";

$binDir = $ENV{"NIX_BIN_DIR"} || "/nix/store/a1kr8kds4jdvvfl6z4gj0gr9w27awhnd-nix-1.8/bin";
$libexecDir = $ENV{"NIX_LIBEXEC_DIR"} || "/nix/store/a1kr8kds4jdvvfl6z4gj0gr9w27awhnd-nix-1.8/libexec";
$stateDir = $ENV{"NIX_STATE_DIR"} || "/nix/var/nix";
$manifestDir = $ENV{"NIX_MANIFESTS_DIR"} || "/nix/var/nix/manifests";
$logDir = $ENV{"NIX_LOG_DIR"} || "/nix/var/log/nix";
$confDir = $ENV{"NIX_CONF_DIR"} || "/etc/nix";
$storeDir = $ENV{"NIX_STORE_DIR"} || "/nix/store";

$bzip2 = "/nix/store/hjykkqr5hk208nnrc727cc2hqc32smx6-bzip2-1.0.6/bin/bzip2";
$xz = "/nix/store/9zm81madq885zb1lsfxpn4rw5y4zcxqm-xz-5.0.7/bin/xz";
$curl = "/nix/store/li2fr9cwc01cc59v0b8qgildx4zc64gs-curl-7.39.0/bin/curl";
$openssl = "/nix/store/rg0ys3sp2ncwisbryy6grx946lsxnkvw-openssl-1.0.1j/bin/openssl";

$useBindings = "yes" eq "yes";

%config = ();

sub readConfig {
    if (defined $ENV{'_NIX_OPTIONS'}) {
        foreach my $s (split '\n', $ENV{'_NIX_OPTIONS'}) {
            my ($n, $v) = split '=', $s, 2;
            $config{$n} = $v;
        }
        return;
    }

    my $config = "$confDir/nix.conf";
    return unless -f $config;

    open CONFIG, "<$config" or die "cannot open ‘$config’";
    while (<CONFIG>) {
        /^\s*([\w\-\.]+)\s*=\s*(.*)$/ or next;
        $config{$1} = $2;
    }
    close CONFIG;
}

return 1;
